#!/usr/bin/env python
#	"$Name:  $";
#	"$Header:  $";
#=============================================================================
#
# file :        Bookmarkmanager.py
#
# description : Python source for the Bookmarkmanager and its commands. 
#                The class is derived from Device. It represents the
#                CORBA servant object which will be accessed from the
#                network. All commands which can be executed on the
#                Bookmarkmanager are implemented in this file.
#
# project :     TANGO Device Server
#
# $Author:  $
#
# $Revision:  $
#
# $Log:  $
#
# copyleft :    European Synchrotron Radiation Facility
#               BP 220, Grenoble 38043
#               FRANCE
#
#=============================================================================
#  		This file is generated by POGO
#	(Program Obviously used to Generate tango Object)
#
#         (c) - Software Engineering Group - ESRF
#=============================================================================
#


import PyTango
import sys, time
import ast

#==================================================================
#   Bookmarkmanager Class Description:
#
#         Export attributes for the event system.
#
#==================================================================


class Bookmarkmanager(PyTango.Device_4Impl):

#--------- Add you global variables here --------------------------

#------------------------------------------------------------------
#	Device constructor
#------------------------------------------------------------------
	def __init__(self,cl, name):
    	
		PyTango.Device_4Impl.__init__(self,cl,name)
        	self.debug_stream("In __init__()")
        	Bookmarkmanager.init_device(self)
        	#----- PROTECTED REGION ID(Bookmarkmanager.__init__) ENABLED START -----#
		# internal Python dictionary holding bookmarks
        	self.BookmarkSourceListDict = {} 
		self.BookmarkDict = {}
        	#----- PROTECTED REGION END -----#	//	Bookmarkmanager.__init__

#------------------------------------------------------------------
#	Device destructor
#------------------------------------------------------------------
	def delete_device(self):
		#print "[Device delete_device method] for device",self.get_name()
		return


#------------------------------------------------------------------
#	Device initialization
#------------------------------------------------------------------
	def init_device(self):
		#print "In ", self.get_name(), "::init_device()"
		self.get_device_properties(self.get_device_class())
		
		#
		self.attr_BookmarksSourceList_read = ""
		self.attr_BookmarksName_read = ""
		#
		self.MYSELF_Proxy= PyTango.DeviceProxy(self.get_name())

#------------------------------------------------------------------
#	Always excuted hook method
#------------------------------------------------------------------
	def always_executed_hook(self):
		#print "In ", self.get_name(), "::always_excuted_hook()"
		return
		
#==================================================================
#
#	Bookmarkmanager read/write attribute methods
#
#==================================================================
#------------------------------------------------------------------
#	Read Attribute Hardware
#------------------------------------------------------------------
	def read_attr_hardware(self,data):
		#print "In ", self.get_name(), "::read_attr_hardware()"
		return

	#------------------------------------------------------------------
	#	Read BookmarksDevList attribute
	#------------------------------------------------------------------
	def read_BookmarksDevList(self, attr):
		self.debug_stream("In read_BookmarksSourceList()")
		#	Add your own code here

	       	#----- PROTECTED REGION ID(Bookmarkmanager.BookmarkList_read) ENABLED START -----#
		self.attr_BookmarksSourceList_read = str(self.BookmarkSourceListDict)
        	attr.set_value(self.attr_BookmarksSourceList_read)
        	#----- PROTECTED REGION END -----#	//	BookmarkManager.BookmarksSourceList_read

	#------------------------------------------------------------------
	#	Write BookmarksDevList attribute
	#------------------------------------------------------------------
	def write_BookmarksDevList(self, attr):
        	self.debug_stream("In write_BookmarksSourceList()")
		#	Add your own code here
        	data=attr.get_write_value()
	       	#----- PROTECTED REGION ID(Bookmarkmanager.BookmarkList_read) ENABLED START -----#		
		
		self.BookmarkSourceListDict.update(ast.literal_eval(data))
		# check if evaluated expression is a dict and assign to attribute
		if type(self.BookmarkSourceListDict) == dict:
			self.attr_BookmarksSourceList_read = str(self.BookmarkSourceListDict)
		else:
			self.BookmarkSourceListDict = {}
			self.attr_BookmarksSourceList_read = ''
        	#----- PROTECTED REGION END -----#	//	ValueBookmarks.BookmarkList_write
		
	#------------------------------------------------------------------
	#	Read BookmarksName attribute
	#------------------------------------------------------------------
	def read_BookmarksName(self, attr):
       		self.debug_stream("In read_BookmarksName()")
			
		#	Add your own code here
		self.attr_BookmarksName_read = str(self.BookmarkDict)
		attr.set_value(self.attr_BookmarksName_read)


	#------------------------------------------------------------------
	#	Write BookmarksName attribute
	#------------------------------------------------------------------
	def write_BookmarksName(self, attr):
      		self.debug_stream("In write_BookmarksName()")
		data=attr.get_write_value()
		self.BookmarkDict.update(ast.literal_eval(data))
		# check if evaluated expression is a dict and assign to attribute
		if type(self.BookmarkDict) == dict:
			self.attr_BookmarksName_read = str(self.BookmarkDict)
		else:
			self.BookmarkDict = {}
			self.attr_BookmarksName_read = ''
		

#==================================================================
#
#    Bookmarkmanager command methods
#
#==================================================================
	#------------------------------------------------------------------
	#	Add_BookmarkSource command:
	
	#
	#	Description: Add bookmark source.
	#                Argin: {'dev_name':[read_function,write_function, data_type/attr or cmd]}
	#                
	#	argin:  DevString	Bookmark Source
	#------------------------------------------------------------------
	def Add_BookmarkSource(self, argin):
		self.debug_stream("In write_BookmarksName()")
		#	Add your own code here
		self.BookmarkSourceListDict.update(ast.literal_eval(argin))
		self.MYSELF_Proxy.write_attribute("BookmarksDevList",str(self.BookmarkSourceListDict))
		self.debug_stream("\nBookmarkSource --> " + str(self.BookmarkSourceListDict))

	#------------------------------------------------------------------
	#	Del_BookmarkSource command:
	#
	#	Description: Delete bookmark source.
	#                Argin: dev_name
	#                
	#	argin:  DevString	Bookmark Source
	#------------------------------------------------------------------
	def Del_BookmarkSource(self, argin):
		print "In ", self.get_name(), "::Del_BookmarkSource()"
		#	Add your own code here
		if argin in self.BookmarkSourceListDict.keys():
			del self.BookmarkSourceListDict[argin]
			self.MYSELF_Proxy.write_attribute("BookmarksDevList",str(self.BookmarkSourceListDict))
		else:
			PyTango.Except.throw_exception("Bookmark does not exist","Trying to delete a non-existant bookmark","DeleteBookmark()")

		for v in self.BookmarkDict.values():
			if argin in v.keys():
				del v[argin]
		self.MYSELF_Proxy.write_attribute("BookmarksName",str(self.BookmarkDict))

	#------------------------------------------------------------------
	#	Get_Bookmarks command:
	#
	#	Description: Get bookmark list.
	#                
	#------------------------------------------------------------------
	def Get_Bookmarks(self):
		print "In ", self.get_name(), "::Get_Bookmarks()"
		#	Add your own code here
		argout = str(self.BookmarkDict)
		self.debug_stream("\n"+ str(argout))
		return argout

	#------------------------------------------------------------------
	#	Read_Bookmark command:
	#
	#	Description: Get the values of a bookmark.
	#                Argin: bookmark name.
	#                
	#	argin:  DevString	Bookmark name
	#------------------------------------------------------------------
	def Read_BookmarkInfo(self, argin):
		print "In ", self.get_name(), "::Read_Bookmark()"
		#	Add your own code here
		#bookmarkInfo = str(self.BookmarkDict[argin])
		bookmarkInfo = ''.join('{0} = {1}\n'.format(key, val) for key, val in self.BookmarkDict[argin].items())
		#argout = str(argin) + " : \n" + bookmarkInfo[:-1]
		argout = bookmarkInfo[:-1]
		self.debug_stream("\n"+ str(argout))
		return argout

	#------------------------------------------------------------------
	#	Set_Bookmark command:
	#
	#	Description: Set the values of a bookmark.
	#                Argin: bookmark name.
	#                
	#	argin:  DevString	Bookmark name
	#------------------------------------------------------------------
	def Set_Bookmark(self, argin):
       		self.debug_stream("In Set_Bookmark(bookmark_name)")
		#	Add your own code here
		bookmarkInfoDict = self.BookmarkDict[argin]
		deviceList = self.BookmarkSourceListDict.keys()
		for dev in deviceList:
			target =  bookmarkInfoDict[dev]
			source = self.BookmarkSourceListDict[dev]
			write_method = source[1].strip()
			value_type = source[2].strip()
			source_type = source[3].strip()
			print source
			#
			if value_type=="double":
				targetValue = float( bookmarkInfoDict[dev])
			elif value_type=="short":
				targetValue = int( bookmarkInfoDict[dev])
			elif value_type=="string":
				targetValue = str( bookmarkInfoDict[dev])
			else:
				print "unsupported format"
				return
			
			#
			if source_type=="ATTR":
				msg =  "\nwriting attribute --> " + write_method
				self.debug_stream(msg)
				try:
					valueProxy = PyTango.AttributeProxy(str(write_method))			
					#print "se scommenti mi muovero' a: ", targetValue
					valueProxy.write(targetValue)
				except Exception, ex:
		    			print "--> ", str(ex)
					self.error_stream("Unable to connect to attribute: "+write_method)
					return
					
			elif source_type=="CMD":
				command = write_method[write_method.rfind("/")+1:]
				dev_name = write_method[:write_method.rfind("/")]
				msg =  "\nexecuting command --> " + write_method
				msg +=  "\ntarget value  --> " + str(targetValue)
				self.debug_stream(msg)
				try:
					devProxy = PyTango.DeviceProxy(str(dev_name))
					#print "se scommenti mi muovero' a: ", targetValue
					devProxy.command_inout(str(command),targetValue)
				except Exception, ex:
		    			print "--> ", str(ex)
					self.error_stream("Unable to connect to dev: "+dev_name)
					return

			else:
				print "UNKNOWN"
				return

	#------------------------------------------------------------------
	#	Store_Bookmark command:
	#
	#	Description: Store  bookmark value.
	#                Argin: bookmark name.
	#                
	#	argin:  DevString	Bookmark name
	#------------------------------------------------------------------
	def Store_Bookmark(self, argin):
      		self.debug_stream("In Store_Bookmark(bookmark_name)")
		#	Add your own code here

		if not bool(self.BookmarkSourceListDict):
			self.error_stream("No Source stored.Please add source before store bookmark.")
			return
		
		bookmarkName = str(argin)
		deviceList = self.BookmarkSourceListDict.keys()
		deviceValues = self.BookmarkSourceListDict.values()

		# create device proxy for reading values
		deviceProxy = []
		for dev in deviceValues:
		    try:	    
			    #tangoHost = "xpress-control1:10000/"
			    #valueProxy = PyTango.AttributeProxy(str(tangoHost+dev[0]))
			    valueProxy = PyTango.AttributeProxy(str(dev[0]))
			    deviceProxy.append(valueProxy)
		
		    except Exception, ex:
		    	    print "--> ", str(ex)
			    valueProxy = None
			    self.error_stream("Unable to connect to attribute: "+dev[0])
			    return
		

		dataDict = {}
		for (i,proxy) in enumerate(deviceProxy):
			dataDict[deviceList[i]] = proxy.read().value 
		dd = time.strftime('%x %X')
		dataDict['DATE'] = dd

		data = '{\''+ bookmarkName +'\':' + str(dataDict) +"}"
		print data
		self.BookmarkDict.update(ast.literal_eval(data))
		self.MYSELF_Proxy.write_attribute("BookmarksName",str(self.BookmarkDict))



	#------------------------------------------------------------------
	#	Del_Bookmark command:
	#
	#	Description: Delete a bookmark.
	#                Argin: bookmark name.
	#                
	#	argin:  DevString	Bookmark name
	#------------------------------------------------------------------
	def Del_Bookmark(self, argin):
		print "In ", self.get_name(), "::Del_Bookmark()"
		#	Add your own code here
		if argin in self.BookmarkDict.keys():
			del self.BookmarkDict[argin]
			self.MYSELF_Proxy.write_attribute("BookmarksName",str(self.BookmarkDict))
		else:
			PyTango.Except.throw_exception("Bookmark does not exist","Trying to delete a non-existant bookmark","DeleteBookmark()")

#==================================================================
#
#	BookmarkmanagerClass class definition
#
#==================================================================
class BookmarkmanagerClass(PyTango.DeviceClass):

	#	Class Properties
	class_property_list = {
		}


	#	Device Properties
	device_property_list = {

		}


	#	Command definitions
	cmd_list = {
		    'Add_BookmarkSource':
			    [[PyTango.DevString, "Bookmark Source"],
			    [PyTango.DevVoid, ""]],
		    'Del_BookmarkSource':
			    [[PyTango.DevString, "Bookmark Source"],
			    [PyTango.DevVoid, ""]],
		    'Get_Bookmarks':
			    [[PyTango.DevVoid, ""],
			    [PyTango.DevString, ""]],
		    'Read_BookmarkInfo':
			    [[PyTango.DevString, "Bookmark name"],
			    [PyTango.DevString, ""]],
		    'Set_Bookmark':
			    [[PyTango.DevString, "Bookmark name"],
			    [PyTango.DevVoid, ""]],
		    'Store_Bookmark':
			    [[PyTango.DevString, "Bookmark name"],
			    [PyTango.DevVoid, ""]],
		    'Del_Bookmark':
			    [[PyTango.DevString, "Bookmark name"],
			    [PyTango.DevVoid, ""]],
		}


	#	Attribute definitions
	attr_list = {
		    'BookmarksDevList':
			    [[PyTango.DevString,
			    PyTango.SCALAR,
			    PyTango.READ_WRITE],
			    {
				    'description':"Source list for bookmarks stored as a dictionary :\n{'dev_name':[read_function,write_function, data_type/attr or cmd]}",
				    'Memorized':"true",
			    } ],
		    'BookmarksName':
			    [[PyTango.DevString,
			    PyTango.SCALAR,
			    PyTango.READ_WRITE],
			    {
				    'Memorized':"true",
			    } ],
		}



#------------------------------------------------------------------
#	BookmarkmanagerClass Constructor
#------------------------------------------------------------------
	def __init__(self, name):
		PyTango.DeviceClass.__init__(self, name)
		self.set_type(name);
		#print "In BookmarkmanagerClass  constructor"

#==================================================================
#
#	Bookmarkmanager class main method
#
#==================================================================
if __name__ == '__main__':
	try:
		py = PyTango.Util(sys.argv)
		py.add_TgClass(BookmarkmanagerClass,Bookmarkmanager,'Bookmarkmanager')

		U = PyTango.Util.instance()
		U.server_init()
		U.server_run()

	except PyTango.DevFailed,e:
		print '-------> Received a DevFailed exception:',e
	except Exception,e:
		print '-------> An unforeseen exception occured....',e
